package com.tigrek.iuea.ai;
import java.util.Random;

//Main class  ***
public class GA {
	Population population ; // 10
	Chromosome fittest;
	Chromosome secondFittest;
	public static final boolean FINAL=true;
	public static final int RUNLIMIT=1000;
	public static final int TIMES=1000;
	public static final int GENEVALUE=60;
	int generationCount = 0;
	boolean found=false;
	//Selection
	public GA()
	{
		Random rn = new Random();
		//Initialize population
		population=new Population(10);
		population.printPopulation();
		population.calculateFitness();
		population.printFitness();
		if(!GA.FINAL)
			System.out.println("Generation: " + generationCount + " Fittest: " + population.fittest);
		while ( !found && generationCount<RUNLIMIT) { // population.fittest > 0.8
			++generationCount;
			population.calculateProbability();
			population.calculateCumulativeProb();
			population.Selection();
			population.CrossSelection();
			population.CrossAction();
			population.CrossPlaced();
			population.printNewPopulation();
			population.mutation();
			population.printNewPopulation();
			population.setNewPopulation();
			//Calculate new fitness value
			population.calculateFitness();
			population.printFitness();
			if(population.fittest>0.99)
				found=true;
		}
		if(found)
		{
			System.out.print("Solution found! generation \t" + generationCount);
			System.out.print("\tFitness: \t"+population.getFittest().fitness);
			System.out.print(" Genes: \t");
			String [] c= {"a=","b=","c=","d="};
			for (int i = 0; i < population.chromosomes.get(0).geneLength; i++) {
				System.out.print(c[i]+population.getFittest().genes[i]+"\t");
			}
			System.out.println("");
		}else
		{
			System.out.println("Solution NOT found in "+generationCount+" generation ");
		}
	}
    public static void main(String[] args) {
    	for(int i=0;i<TIMES;i++)
    	{
    		GA demo = new GA();
    	}
    }
}


